1. 题目描述
$m \times n$的迷宫(最大为$16 \times 16$)包含最多3个点,这些点可以同时向相邻方向移动或保持停止,使用小写字母表示起始位置,使用大写字母表示中止位置。求最少经过多少时间,这些点可以从起始位置移动到对应的终止位置。

2. 基本思路
这是很经典的路径搜索问题,一般采用BFS。因为题目说每个$2 \times 2$个子矩阵,都至少有一个点为#,那么起始空白可走的点一定很少,因此,可以预处理这些点可以通过1个时间单位到达的有效位置。这样可以降低$5^3$的总排列。显然,同时对三个点组成的三元组进行状态压缩,这里采用移位。这些做完了,普通的BFS+map就已经可以解出正确解了。但是太慢了。因此,使用双向BFS+map,发现还是超时,原因是map太慢了(而且会随着状态的增加越来越慢)。那么,直接用数组存(注意不要MLE)。直接过了。双向BFS明显地提高了性能。

3. 代码

 /* 3523 */
#include <iostream>
#include <sstream>
#include <string>
#include <map>
#include <queue>
#include <set>
#include <stack>
#include <vector>
#include <deque>
#include <bitset>
#include <algorithm>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cstring>
#include <climits>
#include <cctype>
#include <cassert>
#include <functional>
#include <iterator>
#include <iomanip>
using namespace std;
//#pragma comment(linker,"/STACK:102400000,1024000") #define sti set<int>
#define stpii set<pair<int, int> >
#define mpii map<int,int>
#define vi vector<int>
#define pii pair<int,int>
#define vpii vector<pair<int,int> >
#define rep(i, a, n) for (int i=a;i<n;++i)
#define per(i, a, n) for (int i=n-1;i>=a;--i)
#define clr clear
#define pb push_back
#define mp make_pair
#define fir first
#define sec second
#define all(x) (x).begin(),(x).end()
#define SZ(x) ((int)(x).size())
#define lson l, mid, rt<<1
#define rson mid+1, r, rt<<1|1
#define INF 0x3f3f3f3f
#define mset(a, val) memset(a, (val), sizeof(a)) const int maxn = ;
const int maxm = ;
int ID[maxn][maxn];
int sz[maxm];
int Move[maxm][];
int visit[][maxm][maxm][maxm];
char s[maxn][maxn];
map<char,int> ptb;
queue<int> Q[];
int dir[][] = {
-, , , , , -, , , ,
};
int n, m, gn;
int st, ed; inline bool judge(int x, int y) {
return x< || x>=n || y< || y>=m || s[x][y]=='#';
} void init() {
int cnt = ;
map<char,int>::iterator iter; ptb.clr(); rep(i, , n) {
rep(j, , m) {
if (s[i][j] == '#')
continue; ID[i][j] = cnt++;
if (s[i][j] != ' ')
ptb[s[i][j]] = ID[i][j];
}
} rep(i, , n) {
rep(j, , m) {
if (s[i][j] == '#')
continue; const int& id = ID[i][j];
sz[id] = ;
Move[id][] = id;
rep(k, , ) {
int x = i + dir[k][];
int y = j + dir[k][];
if (judge(x, y))
continue; Move[id][sz[id]++] = ID[x][y];
}
}
} st = ed = ; for (char ch='a'; ch<='z'; ++ch) {
iter = ptb.find(ch);
if (iter != ptb.end()) {
st = (st << ) | iter->sec;
iter = ptb.find(ch-'a'+'A');
#ifndef ONLINE_JUDGE
assert(iter != ptb.end());
#endif
ed = (ed << ) | iter->sec;
}
}
} int bfs1(const int qid) {
int cst, nst;
int qsz = SZ(Q[qid]); while (qsz--) {
cst = Q[qid].front();
Q[qid].pop(); int step = visit[qid][][][cst] + ;
rep(i, , sz[cst]) {
nst = Move[cst][i];
if (visit[qid][][][nst] == -) {
if (visit[qid^][][][nst] >= )
return step + visit[qid^][][][nst];
visit[qid][][][nst] = step;
Q[qid].push(nst);
}
}
} return -;
} int bfs2(const int qid) {
int cst[], nst[], tmp;
int qsz = SZ(Q[qid]); while (qsz--) {
st = Q[qid].front();
Q[qid].pop(); per(i, , ) {
cst[i] = st & 0xff;
st >>= ;
} int step = visit[qid][][cst[]][cst[]] + ; rep(i, , sz[cst[]]) {
nst[] = Move[cst[]][i];
rep(j, , sz[cst[]]) {
nst[] = Move[cst[]][j];
if (nst[]==nst[] || (nst[]==cst[]&&nst[]==cst[]))
continue; tmp = nst[]<< | nst[];
if (visit[qid][][nst[]][nst[]] == -) {
if (visit[qid^][][nst[]][nst[]] != -)
return step + visit[qid^][][nst[]][nst[]];
visit[qid][][nst[]][nst[]] = step;
Q[qid].push(tmp);
}
}
}
} return -;
} inline bool check(int *nst, int *cst) {
return (nst[]==cst[] && nst[]==cst[]) || (nst[]==cst[] && nst[]==cst[]) || (nst[]==cst[] && nst[]==cst[]);
} int bfs3(const int qid) {
int cst[], nst[], tmp;
int qsz = SZ(Q[qid]); while (qsz--) {
st = Q[qid].front();
Q[qid].pop(); per(i, , ) {
cst[i] = st & 0xff;
st >>= ;
} int step = visit[qid][cst[]][cst[]][cst[]] + ; rep(i, , sz[cst[]]) {
nst[] = Move[cst[]][i];
rep(j, , sz[cst[]]) {
nst[] = Move[cst[]][j];
rep(k, , sz[cst[]]) {
nst[] = Move[cst[]][k];
if (nst[]==nst[] || nst[]==nst[] || nst[]==nst[] || check(cst, nst))
continue; tmp = (nst[]<<) | (nst[]<<) | (nst[]); if (visit[qid][nst[]][nst[]][nst[]] == -) {
if (visit[qid^][nst[]][nst[]][nst[]] != -)
return step + visit[qid^][nst[]][nst[]][nst[]];
visit[qid][nst[]][nst[]][nst[]] = step;
Q[qid].push(tmp);
}
}
}
}
} return -;
} #define bibfs(n)\
int bibfs##n() {\
int tmp; \
\
while (!Q[].empty() || !Q[].empty()) {\
tmp = bfs##n();\
if (tmp >= ) return tmp;\
tmp = bfs##n();\
if (tmp >= ) return tmp;\
}\
\
return -;\
} #define callbibfs(n) bibfs##n() bibfs()
bibfs()
bibfs() void solve() {
init();
int ans; memset(visit, -, sizeof(visit));
rep(i, , )
while (!Q[i].empty()) Q[i].pop();
visit[][st>>][(st>>)&0xff][st&0xff] = ;
visit[][ed>>][(ed>>)&0xff][ed&0xff] = ;
Q[].push(st);
Q[].push(ed); if (gn == ) {
ans = callbibfs();
} else if (gn == ) {
ans = callbibfs();
} else {
ans = callbibfs();
} printf("%d\n", ans);
} int main() {
ios::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
freopen("data.in", "r", stdin);
freopen("data.out", "w", stdout);
#endif while (scanf("%d%d%d%*c",&m,&n,&gn)!=EOF && (n||m||gn)) {
rep(i, , n)
gets(s[i]);
solve();
} #ifndef ONLINE_JUDGE
printf("time = %d.\n", (int)clock());
#endif return ;
}

【POJ】3523 The Morning after Halloween的更多相关文章

  1. 【POJ】1704 Georgia and Bob(Staircase Nim)

    Description Georgia and Bob decide to play a self-invented game. They draw a row of grids on paper, ...

  2. 【POJ】1067 取石子游戏(博弈论)

    Description 有两堆石子,数量任意,可以不同.游戏开始由两个人轮流取石子.游戏规定,每次有两种不同的取法,一是可以在任意的一堆中取走任意多的石子:二是可以在两堆中同时取走相同数量的石子.最后 ...

  3. 【BZOJ】【1986】【USACO 2004 Dec】/【POJ】【2373】划区灌溉

    DP/单调队列优化 首先不考虑奶牛的喜欢区间,dp方程当然是比较显然的:$ f[i]=min(f[k])+1,i-2*b \leq k \leq i-2*a $  当然这里的$i$和$k$都是偶数啦~ ...

  4. 【POJ】【2104】区间第K大

    可持久化线段树 可持久化线段树是一种神奇的数据结构,它跟我们原来常用的线段树不同,它每次更新是不更改原来数据的,而是新开节点,维护它的历史版本,实现“可持久化”.(当然视情况也会有需要修改的时候) 可 ...

  5. 【POJ】1222 EXTENDED LIGHTS OUT

    [算法]高斯消元 [题解] 高斯消元经典题型:异或方程组 poj 1222 高斯消元详解 异或相当于相加后mod2 异或方程组就是把加减消元全部改为异或. 异或性质:00 11为假,01 10为真.与 ...

  6. 【POJ】2892 Tunnel Warfare

    [算法]平衡树(treap) [题解]treap知识见数据结构 在POJ把语言从G++换成C++就过了……??? #include<cstdio> #include<algorith ...

  7. 【POJ】【1637】Sightseeing tour

    网络流/最大流 愚人节快乐XD 这题是给一个混合图(既有有向边又有无向边),让你判断是否有欧拉回路…… 我们知道如果一个[连通]图中每个节点都满足[入度=出度]那么就一定有欧拉回路…… 那么每条边都可 ...

  8. 【poj】1001

    [题目] ExponentiationTime Limit: 500MS Memory Limit: 10000KTotal Submissions: 123707 Accepted: 30202De ...

  9. 【POJ】3070 Fibonacci

    [算法]矩阵快速幂 [题解] 根据f[n]=f[n-1]+f[n-2],可以构造递推矩阵: $$\begin{vmatrix}1 & 1\\ 1 & 0\end{vmatrix} \t ...

随机推荐

  1. QQ群里收集的外企iOS开发的笔试题

    一组外企iOS开发的笔试题,您能回答出来吗?从群里收集来的. 1 why can't NSArray contain NSInteger Instance? with which extra step ...

  2. [转]宏的高级使用--##,__VA_ARGS__, __FILE__, __FUNCTION__等

    [转]宏的高级使用--##,__VA_ARGS__, __FILE__, __FUNCTION__等 http://blog.csdn.net/yiya1989/article/details/784 ...

  3. Underscore 源码

    Underscore 源码 作者:韩子迟 What? 不知不觉间,「Underscore 源码解读系列」进入了真正的尾声,也请允许我最后一次 po 下项目的原始地址 https://github.co ...

  4. 精灵的属性Zorder的设置

    1.Zorder是CCSprite从父类CCNode那继承来的protected属性: class CCNode{ protected: int m_nZOrder;                  ...

  5. HTML5 本地裁剪图片

    下面奉上我自己写的一个demo,代码写得比较少,很多细节不会处理.如果有不得当的地方恳请指教,谢谢啦 ^_^ ^_^   功能实现步奏:   一:获取文件,读取文件并生成url   二:根据容器的大小 ...

  6. Reactjs相比较原生方案是绝对的快吗?哪些情况下React有优势

    作者:尤雨溪链接:http://www.zhihu.com/question/31809713/answer/53544875来源:知乎著作权归作者所有,转载请联系作者获得授权.   1. 原生 DO ...

  7. 剑指offer--面试题12

    题目:打印从1~最大的n位数 分析:知道陷阱在哪,即n很大时若用通常的int,long会溢出:想到用字符串解决,这涉及到字符转数字及反过来. 刚开始纠结于字符串怎么加1,想了片刻,觉得应该取出最后一位 ...

  8. PE工具

    PE编辑工具 Stud_PE v. 2.4.0.1 PE工具,用来学习PE格式十分方便. http://www.cgsoftlabs.ro/ 汉化版:http://bbs.pediy.com/show ...

  9. oracle实现自增列

    手动创建了一个表格,但是id字段无法实现自增,查看了一下网上的信息,没有找到满意的答案.一下是自己总结摸索的,仅供参考 第一步:手动创建表和列中的字段 (本例中,表明 T_VIDEO,第一个字段:ID ...

  10. mysql的学习记录

    1 MySQL -h localhost -u UserName -p Password-h不写,默认为localhost注意:最好先MySQL -h localhost -u UserName -p ...